---
title: "Style Guides"
---

OpenTitan's CI enforces what it can of the following style guides to avoid conflict, toil and confusion.
However, code reviewers are also responsible for enforcing coding style guidelines and best practices.

- [RISC-V Assembly Style Guide]({{< relref "asm_coding_style" >}})
- [C and C++ Coding Style Guide]({{< relref "c_cpp_coding_style" >}})
- [Hjson Usage and Style Guide]({{< relref "hjson_usage_style" >}})
- [Markdown Usage and Style Guide]({{< relref "markdown_usage_style" >}})
- [OTBN Assembly Style Guide]({{< relref "otbn_style_guide" >}})
- [Python Coding Style Guide]({{< relref "python_coding_style" >}})
- [Verilog Coding Style Guide](https://github.com/lowRISC/style-guides/blob/master/VerilogCodingStyle.md)
- [SystemVerilog Coding Style Guide for Design Verification (DV)](https://github.com/lowRISC/style-guides/blob/master/DVCodingStyle.md)
