---
title: "Use Cases"
---

## Overview

OpenTitan's mission is to raise the security bar industry-wide by implementing a
transparent, logically secure hardware root of trust with wide application.

This document describes some of those use cases for OpenTitan. These range from
data center integrations, to embedded security applications such as security
keys and smart cards. References to relevant specifications and certification
targets are noted where use cases are backed by industry standards.

## Discrete Use Cases

* [Platform Integrity Module]({{< relref "doc/use_cases/platform_integrity_module" >}})
* [Universal 2nd-Factor Security Key]({{< relref "doc/use_cases/u2f" >}})
* [Trusted Platform Module]({{< relref "doc/use_cases/tpm" >}})
