// Copyright lowRISC contributors.
// Licensed under the Apache License, Version 2.0, see LICENSE for details.
// SPDX-License-Identifier: Apache-2.0
//
// Register Package auto-generated by `reggen` containing data structure

package rv_dm_reg_pkg;

  // Param list
  parameter int NrHarts = 1;
  parameter int NumAlerts = 1;

  // Address widths within the block
  parameter int RegsAw = 2;
  parameter int MemAw = 12;

  ///////////////////////////////////////////////
  // Typedefs for registers for regs interface //
  ///////////////////////////////////////////////

  typedef struct packed {
    logic        q;
    logic        qe;
  } rv_dm_reg2hw_alert_test_reg_t;

  // Register -> HW type for regs interface
  typedef struct packed {
    rv_dm_reg2hw_alert_test_reg_t alert_test; // [1:0]
  } rv_dm_regs_reg2hw_t;

  // Register offsets for regs interface
  parameter logic [RegsAw-1:0] RV_DM_ALERT_TEST_OFFSET = 2'h 0;

  // Reset values for hwext registers and their fields for regs interface
  parameter logic [0:0] RV_DM_ALERT_TEST_RESVAL = 1'h 0;
  parameter logic [0:0] RV_DM_ALERT_TEST_FATAL_FAULT_RESVAL = 1'h 0;

  // Register index for regs interface
  typedef enum int {
    RV_DM_ALERT_TEST
  } rv_dm_regs_id_e;

  // Register width information to check illegal writes for regs interface
  parameter logic [3:0] RV_DM_REGS_PERMIT [1] = '{
    4'b 0001  // index[0] RV_DM_ALERT_TEST
  };

  //////////////////////////////////////////////
  // Typedefs for registers for mem interface //
  //////////////////////////////////////////////

  typedef struct packed {
    logic        q;
  } rv_dm_reg2hw_halted_reg_t;

  typedef struct packed {
    logic        q;
  } rv_dm_reg2hw_going_reg_t;

  typedef struct packed {
    logic        q;
  } rv_dm_reg2hw_resuming_reg_t;

  typedef struct packed {
    logic        q;
  } rv_dm_reg2hw_exception_reg_t;

  typedef struct packed {
    logic [31:0] q;
  } rv_dm_reg2hw_whereto_reg_t;

  typedef struct packed {
    logic [31:0] q;
  } rv_dm_reg2hw_abstractcmd_mreg_t;

  typedef struct packed {
    logic [31:0] q;
  } rv_dm_reg2hw_program_buffer_mreg_t;

  typedef struct packed {
    logic [31:0] q;
  } rv_dm_reg2hw_dataaddr_mreg_t;

  typedef struct packed {
    logic [31:0] q;
  } rv_dm_reg2hw_flags_mreg_t;

  typedef struct packed {
    logic        d;
    logic        de;
  } rv_dm_hw2reg_halted_reg_t;

  typedef struct packed {
    logic [31:0] d;
    logic        de;
  } rv_dm_hw2reg_whereto_reg_t;

  // Register -> HW type for mem interface
  typedef struct packed {
    rv_dm_reg2hw_halted_reg_t halted; // [8867:8867]
    rv_dm_reg2hw_going_reg_t going; // [8866:8866]
    rv_dm_reg2hw_resuming_reg_t resuming; // [8865:8865]
    rv_dm_reg2hw_exception_reg_t exception; // [8864:8864]
    rv_dm_reg2hw_whereto_reg_t whereto; // [8863:8832]
    rv_dm_reg2hw_abstractcmd_mreg_t [9:0] abstractcmd; // [8831:8512]
    rv_dm_reg2hw_program_buffer_mreg_t [7:0] program_buffer; // [8511:8256]
    rv_dm_reg2hw_dataaddr_mreg_t [1:0] dataaddr; // [8255:8192]
    rv_dm_reg2hw_flags_mreg_t [255:0] flags; // [8191:0]
  } rv_dm_mem_reg2hw_t;

  // HW -> register type for mem interface
  typedef struct packed {
    rv_dm_hw2reg_halted_reg_t halted; // [34:33]
    rv_dm_hw2reg_whereto_reg_t whereto; // [32:0]
  } rv_dm_mem_hw2reg_t;

  // Register offsets for mem interface
  parameter logic [MemAw-1:0] RV_DM_HALTED_OFFSET = 12'h 100;
  parameter logic [MemAw-1:0] RV_DM_GOING_OFFSET = 12'h 104;
  parameter logic [MemAw-1:0] RV_DM_RESUMING_OFFSET = 12'h 108;
  parameter logic [MemAw-1:0] RV_DM_EXCEPTION_OFFSET = 12'h 10c;
  parameter logic [MemAw-1:0] RV_DM_WHERETO_OFFSET = 12'h 300;
  parameter logic [MemAw-1:0] RV_DM_ABSTRACTCMD_0_OFFSET = 12'h 338;
  parameter logic [MemAw-1:0] RV_DM_ABSTRACTCMD_1_OFFSET = 12'h 33c;
  parameter logic [MemAw-1:0] RV_DM_ABSTRACTCMD_2_OFFSET = 12'h 340;
  parameter logic [MemAw-1:0] RV_DM_ABSTRACTCMD_3_OFFSET = 12'h 344;
  parameter logic [MemAw-1:0] RV_DM_ABSTRACTCMD_4_OFFSET = 12'h 348;
  parameter logic [MemAw-1:0] RV_DM_ABSTRACTCMD_5_OFFSET = 12'h 34c;
  parameter logic [MemAw-1:0] RV_DM_ABSTRACTCMD_6_OFFSET = 12'h 350;
  parameter logic [MemAw-1:0] RV_DM_ABSTRACTCMD_7_OFFSET = 12'h 354;
  parameter logic [MemAw-1:0] RV_DM_ABSTRACTCMD_8_OFFSET = 12'h 358;
  parameter logic [MemAw-1:0] RV_DM_ABSTRACTCMD_9_OFFSET = 12'h 35c;
  parameter logic [MemAw-1:0] RV_DM_PROGRAM_BUFFER_0_OFFSET = 12'h 360;
  parameter logic [MemAw-1:0] RV_DM_PROGRAM_BUFFER_1_OFFSET = 12'h 364;
  parameter logic [MemAw-1:0] RV_DM_PROGRAM_BUFFER_2_OFFSET = 12'h 368;
  parameter logic [MemAw-1:0] RV_DM_PROGRAM_BUFFER_3_OFFSET = 12'h 36c;
  parameter logic [MemAw-1:0] RV_DM_PROGRAM_BUFFER_4_OFFSET = 12'h 370;
  parameter logic [MemAw-1:0] RV_DM_PROGRAM_BUFFER_5_OFFSET = 12'h 374;
  parameter logic [MemAw-1:0] RV_DM_PROGRAM_BUFFER_6_OFFSET = 12'h 378;
  parameter logic [MemAw-1:0] RV_DM_PROGRAM_BUFFER_7_OFFSET = 12'h 37c;
  parameter logic [MemAw-1:0] RV_DM_DATAADDR_0_OFFSET = 12'h 380;
  parameter logic [MemAw-1:0] RV_DM_DATAADDR_1_OFFSET = 12'h 384;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_0_OFFSET = 12'h 400;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_1_OFFSET = 12'h 404;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_2_OFFSET = 12'h 408;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_3_OFFSET = 12'h 40c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_4_OFFSET = 12'h 410;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_5_OFFSET = 12'h 414;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_6_OFFSET = 12'h 418;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_7_OFFSET = 12'h 41c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_8_OFFSET = 12'h 420;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_9_OFFSET = 12'h 424;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_10_OFFSET = 12'h 428;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_11_OFFSET = 12'h 42c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_12_OFFSET = 12'h 430;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_13_OFFSET = 12'h 434;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_14_OFFSET = 12'h 438;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_15_OFFSET = 12'h 43c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_16_OFFSET = 12'h 440;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_17_OFFSET = 12'h 444;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_18_OFFSET = 12'h 448;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_19_OFFSET = 12'h 44c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_20_OFFSET = 12'h 450;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_21_OFFSET = 12'h 454;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_22_OFFSET = 12'h 458;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_23_OFFSET = 12'h 45c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_24_OFFSET = 12'h 460;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_25_OFFSET = 12'h 464;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_26_OFFSET = 12'h 468;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_27_OFFSET = 12'h 46c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_28_OFFSET = 12'h 470;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_29_OFFSET = 12'h 474;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_30_OFFSET = 12'h 478;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_31_OFFSET = 12'h 47c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_32_OFFSET = 12'h 480;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_33_OFFSET = 12'h 484;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_34_OFFSET = 12'h 488;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_35_OFFSET = 12'h 48c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_36_OFFSET = 12'h 490;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_37_OFFSET = 12'h 494;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_38_OFFSET = 12'h 498;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_39_OFFSET = 12'h 49c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_40_OFFSET = 12'h 4a0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_41_OFFSET = 12'h 4a4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_42_OFFSET = 12'h 4a8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_43_OFFSET = 12'h 4ac;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_44_OFFSET = 12'h 4b0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_45_OFFSET = 12'h 4b4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_46_OFFSET = 12'h 4b8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_47_OFFSET = 12'h 4bc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_48_OFFSET = 12'h 4c0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_49_OFFSET = 12'h 4c4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_50_OFFSET = 12'h 4c8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_51_OFFSET = 12'h 4cc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_52_OFFSET = 12'h 4d0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_53_OFFSET = 12'h 4d4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_54_OFFSET = 12'h 4d8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_55_OFFSET = 12'h 4dc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_56_OFFSET = 12'h 4e0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_57_OFFSET = 12'h 4e4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_58_OFFSET = 12'h 4e8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_59_OFFSET = 12'h 4ec;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_60_OFFSET = 12'h 4f0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_61_OFFSET = 12'h 4f4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_62_OFFSET = 12'h 4f8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_63_OFFSET = 12'h 4fc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_64_OFFSET = 12'h 500;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_65_OFFSET = 12'h 504;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_66_OFFSET = 12'h 508;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_67_OFFSET = 12'h 50c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_68_OFFSET = 12'h 510;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_69_OFFSET = 12'h 514;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_70_OFFSET = 12'h 518;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_71_OFFSET = 12'h 51c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_72_OFFSET = 12'h 520;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_73_OFFSET = 12'h 524;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_74_OFFSET = 12'h 528;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_75_OFFSET = 12'h 52c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_76_OFFSET = 12'h 530;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_77_OFFSET = 12'h 534;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_78_OFFSET = 12'h 538;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_79_OFFSET = 12'h 53c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_80_OFFSET = 12'h 540;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_81_OFFSET = 12'h 544;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_82_OFFSET = 12'h 548;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_83_OFFSET = 12'h 54c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_84_OFFSET = 12'h 550;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_85_OFFSET = 12'h 554;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_86_OFFSET = 12'h 558;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_87_OFFSET = 12'h 55c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_88_OFFSET = 12'h 560;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_89_OFFSET = 12'h 564;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_90_OFFSET = 12'h 568;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_91_OFFSET = 12'h 56c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_92_OFFSET = 12'h 570;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_93_OFFSET = 12'h 574;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_94_OFFSET = 12'h 578;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_95_OFFSET = 12'h 57c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_96_OFFSET = 12'h 580;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_97_OFFSET = 12'h 584;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_98_OFFSET = 12'h 588;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_99_OFFSET = 12'h 58c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_100_OFFSET = 12'h 590;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_101_OFFSET = 12'h 594;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_102_OFFSET = 12'h 598;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_103_OFFSET = 12'h 59c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_104_OFFSET = 12'h 5a0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_105_OFFSET = 12'h 5a4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_106_OFFSET = 12'h 5a8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_107_OFFSET = 12'h 5ac;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_108_OFFSET = 12'h 5b0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_109_OFFSET = 12'h 5b4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_110_OFFSET = 12'h 5b8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_111_OFFSET = 12'h 5bc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_112_OFFSET = 12'h 5c0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_113_OFFSET = 12'h 5c4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_114_OFFSET = 12'h 5c8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_115_OFFSET = 12'h 5cc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_116_OFFSET = 12'h 5d0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_117_OFFSET = 12'h 5d4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_118_OFFSET = 12'h 5d8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_119_OFFSET = 12'h 5dc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_120_OFFSET = 12'h 5e0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_121_OFFSET = 12'h 5e4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_122_OFFSET = 12'h 5e8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_123_OFFSET = 12'h 5ec;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_124_OFFSET = 12'h 5f0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_125_OFFSET = 12'h 5f4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_126_OFFSET = 12'h 5f8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_127_OFFSET = 12'h 5fc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_128_OFFSET = 12'h 600;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_129_OFFSET = 12'h 604;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_130_OFFSET = 12'h 608;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_131_OFFSET = 12'h 60c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_132_OFFSET = 12'h 610;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_133_OFFSET = 12'h 614;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_134_OFFSET = 12'h 618;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_135_OFFSET = 12'h 61c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_136_OFFSET = 12'h 620;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_137_OFFSET = 12'h 624;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_138_OFFSET = 12'h 628;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_139_OFFSET = 12'h 62c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_140_OFFSET = 12'h 630;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_141_OFFSET = 12'h 634;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_142_OFFSET = 12'h 638;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_143_OFFSET = 12'h 63c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_144_OFFSET = 12'h 640;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_145_OFFSET = 12'h 644;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_146_OFFSET = 12'h 648;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_147_OFFSET = 12'h 64c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_148_OFFSET = 12'h 650;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_149_OFFSET = 12'h 654;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_150_OFFSET = 12'h 658;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_151_OFFSET = 12'h 65c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_152_OFFSET = 12'h 660;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_153_OFFSET = 12'h 664;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_154_OFFSET = 12'h 668;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_155_OFFSET = 12'h 66c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_156_OFFSET = 12'h 670;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_157_OFFSET = 12'h 674;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_158_OFFSET = 12'h 678;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_159_OFFSET = 12'h 67c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_160_OFFSET = 12'h 680;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_161_OFFSET = 12'h 684;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_162_OFFSET = 12'h 688;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_163_OFFSET = 12'h 68c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_164_OFFSET = 12'h 690;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_165_OFFSET = 12'h 694;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_166_OFFSET = 12'h 698;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_167_OFFSET = 12'h 69c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_168_OFFSET = 12'h 6a0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_169_OFFSET = 12'h 6a4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_170_OFFSET = 12'h 6a8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_171_OFFSET = 12'h 6ac;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_172_OFFSET = 12'h 6b0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_173_OFFSET = 12'h 6b4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_174_OFFSET = 12'h 6b8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_175_OFFSET = 12'h 6bc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_176_OFFSET = 12'h 6c0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_177_OFFSET = 12'h 6c4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_178_OFFSET = 12'h 6c8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_179_OFFSET = 12'h 6cc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_180_OFFSET = 12'h 6d0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_181_OFFSET = 12'h 6d4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_182_OFFSET = 12'h 6d8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_183_OFFSET = 12'h 6dc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_184_OFFSET = 12'h 6e0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_185_OFFSET = 12'h 6e4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_186_OFFSET = 12'h 6e8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_187_OFFSET = 12'h 6ec;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_188_OFFSET = 12'h 6f0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_189_OFFSET = 12'h 6f4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_190_OFFSET = 12'h 6f8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_191_OFFSET = 12'h 6fc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_192_OFFSET = 12'h 700;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_193_OFFSET = 12'h 704;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_194_OFFSET = 12'h 708;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_195_OFFSET = 12'h 70c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_196_OFFSET = 12'h 710;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_197_OFFSET = 12'h 714;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_198_OFFSET = 12'h 718;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_199_OFFSET = 12'h 71c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_200_OFFSET = 12'h 720;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_201_OFFSET = 12'h 724;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_202_OFFSET = 12'h 728;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_203_OFFSET = 12'h 72c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_204_OFFSET = 12'h 730;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_205_OFFSET = 12'h 734;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_206_OFFSET = 12'h 738;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_207_OFFSET = 12'h 73c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_208_OFFSET = 12'h 740;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_209_OFFSET = 12'h 744;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_210_OFFSET = 12'h 748;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_211_OFFSET = 12'h 74c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_212_OFFSET = 12'h 750;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_213_OFFSET = 12'h 754;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_214_OFFSET = 12'h 758;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_215_OFFSET = 12'h 75c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_216_OFFSET = 12'h 760;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_217_OFFSET = 12'h 764;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_218_OFFSET = 12'h 768;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_219_OFFSET = 12'h 76c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_220_OFFSET = 12'h 770;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_221_OFFSET = 12'h 774;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_222_OFFSET = 12'h 778;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_223_OFFSET = 12'h 77c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_224_OFFSET = 12'h 780;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_225_OFFSET = 12'h 784;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_226_OFFSET = 12'h 788;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_227_OFFSET = 12'h 78c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_228_OFFSET = 12'h 790;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_229_OFFSET = 12'h 794;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_230_OFFSET = 12'h 798;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_231_OFFSET = 12'h 79c;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_232_OFFSET = 12'h 7a0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_233_OFFSET = 12'h 7a4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_234_OFFSET = 12'h 7a8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_235_OFFSET = 12'h 7ac;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_236_OFFSET = 12'h 7b0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_237_OFFSET = 12'h 7b4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_238_OFFSET = 12'h 7b8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_239_OFFSET = 12'h 7bc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_240_OFFSET = 12'h 7c0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_241_OFFSET = 12'h 7c4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_242_OFFSET = 12'h 7c8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_243_OFFSET = 12'h 7cc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_244_OFFSET = 12'h 7d0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_245_OFFSET = 12'h 7d4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_246_OFFSET = 12'h 7d8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_247_OFFSET = 12'h 7dc;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_248_OFFSET = 12'h 7e0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_249_OFFSET = 12'h 7e4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_250_OFFSET = 12'h 7e8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_251_OFFSET = 12'h 7ec;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_252_OFFSET = 12'h 7f0;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_253_OFFSET = 12'h 7f4;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_254_OFFSET = 12'h 7f8;
  parameter logic [MemAw-1:0] RV_DM_FLAGS_255_OFFSET = 12'h 7fc;

  // Window parameters for mem interface
  parameter logic [MemAw-1:0] RV_DM_ROM_OFFSET = 12'h 800;
  parameter int unsigned      RV_DM_ROM_SIZE   = 'h 800;

  // Register index for mem interface
  typedef enum int {
    RV_DM_HALTED,
    RV_DM_GOING,
    RV_DM_RESUMING,
    RV_DM_EXCEPTION,
    RV_DM_WHERETO,
    RV_DM_ABSTRACTCMD_0,
    RV_DM_ABSTRACTCMD_1,
    RV_DM_ABSTRACTCMD_2,
    RV_DM_ABSTRACTCMD_3,
    RV_DM_ABSTRACTCMD_4,
    RV_DM_ABSTRACTCMD_5,
    RV_DM_ABSTRACTCMD_6,
    RV_DM_ABSTRACTCMD_7,
    RV_DM_ABSTRACTCMD_8,
    RV_DM_ABSTRACTCMD_9,
    RV_DM_PROGRAM_BUFFER_0,
    RV_DM_PROGRAM_BUFFER_1,
    RV_DM_PROGRAM_BUFFER_2,
    RV_DM_PROGRAM_BUFFER_3,
    RV_DM_PROGRAM_BUFFER_4,
    RV_DM_PROGRAM_BUFFER_5,
    RV_DM_PROGRAM_BUFFER_6,
    RV_DM_PROGRAM_BUFFER_7,
    RV_DM_DATAADDR_0,
    RV_DM_DATAADDR_1,
    RV_DM_FLAGS_0,
    RV_DM_FLAGS_1,
    RV_DM_FLAGS_2,
    RV_DM_FLAGS_3,
    RV_DM_FLAGS_4,
    RV_DM_FLAGS_5,
    RV_DM_FLAGS_6,
    RV_DM_FLAGS_7,
    RV_DM_FLAGS_8,
    RV_DM_FLAGS_9,
    RV_DM_FLAGS_10,
    RV_DM_FLAGS_11,
    RV_DM_FLAGS_12,
    RV_DM_FLAGS_13,
    RV_DM_FLAGS_14,
    RV_DM_FLAGS_15,
    RV_DM_FLAGS_16,
    RV_DM_FLAGS_17,
    RV_DM_FLAGS_18,
    RV_DM_FLAGS_19,
    RV_DM_FLAGS_20,
    RV_DM_FLAGS_21,
    RV_DM_FLAGS_22,
    RV_DM_FLAGS_23,
    RV_DM_FLAGS_24,
    RV_DM_FLAGS_25,
    RV_DM_FLAGS_26,
    RV_DM_FLAGS_27,
    RV_DM_FLAGS_28,
    RV_DM_FLAGS_29,
    RV_DM_FLAGS_30,
    RV_DM_FLAGS_31,
    RV_DM_FLAGS_32,
    RV_DM_FLAGS_33,
    RV_DM_FLAGS_34,
    RV_DM_FLAGS_35,
    RV_DM_FLAGS_36,
    RV_DM_FLAGS_37,
    RV_DM_FLAGS_38,
    RV_DM_FLAGS_39,
    RV_DM_FLAGS_40,
    RV_DM_FLAGS_41,
    RV_DM_FLAGS_42,
    RV_DM_FLAGS_43,
    RV_DM_FLAGS_44,
    RV_DM_FLAGS_45,
    RV_DM_FLAGS_46,
    RV_DM_FLAGS_47,
    RV_DM_FLAGS_48,
    RV_DM_FLAGS_49,
    RV_DM_FLAGS_50,
    RV_DM_FLAGS_51,
    RV_DM_FLAGS_52,
    RV_DM_FLAGS_53,
    RV_DM_FLAGS_54,
    RV_DM_FLAGS_55,
    RV_DM_FLAGS_56,
    RV_DM_FLAGS_57,
    RV_DM_FLAGS_58,
    RV_DM_FLAGS_59,
    RV_DM_FLAGS_60,
    RV_DM_FLAGS_61,
    RV_DM_FLAGS_62,
    RV_DM_FLAGS_63,
    RV_DM_FLAGS_64,
    RV_DM_FLAGS_65,
    RV_DM_FLAGS_66,
    RV_DM_FLAGS_67,
    RV_DM_FLAGS_68,
    RV_DM_FLAGS_69,
    RV_DM_FLAGS_70,
    RV_DM_FLAGS_71,
    RV_DM_FLAGS_72,
    RV_DM_FLAGS_73,
    RV_DM_FLAGS_74,
    RV_DM_FLAGS_75,
    RV_DM_FLAGS_76,
    RV_DM_FLAGS_77,
    RV_DM_FLAGS_78,
    RV_DM_FLAGS_79,
    RV_DM_FLAGS_80,
    RV_DM_FLAGS_81,
    RV_DM_FLAGS_82,
    RV_DM_FLAGS_83,
    RV_DM_FLAGS_84,
    RV_DM_FLAGS_85,
    RV_DM_FLAGS_86,
    RV_DM_FLAGS_87,
    RV_DM_FLAGS_88,
    RV_DM_FLAGS_89,
    RV_DM_FLAGS_90,
    RV_DM_FLAGS_91,
    RV_DM_FLAGS_92,
    RV_DM_FLAGS_93,
    RV_DM_FLAGS_94,
    RV_DM_FLAGS_95,
    RV_DM_FLAGS_96,
    RV_DM_FLAGS_97,
    RV_DM_FLAGS_98,
    RV_DM_FLAGS_99,
    RV_DM_FLAGS_100,
    RV_DM_FLAGS_101,
    RV_DM_FLAGS_102,
    RV_DM_FLAGS_103,
    RV_DM_FLAGS_104,
    RV_DM_FLAGS_105,
    RV_DM_FLAGS_106,
    RV_DM_FLAGS_107,
    RV_DM_FLAGS_108,
    RV_DM_FLAGS_109,
    RV_DM_FLAGS_110,
    RV_DM_FLAGS_111,
    RV_DM_FLAGS_112,
    RV_DM_FLAGS_113,
    RV_DM_FLAGS_114,
    RV_DM_FLAGS_115,
    RV_DM_FLAGS_116,
    RV_DM_FLAGS_117,
    RV_DM_FLAGS_118,
    RV_DM_FLAGS_119,
    RV_DM_FLAGS_120,
    RV_DM_FLAGS_121,
    RV_DM_FLAGS_122,
    RV_DM_FLAGS_123,
    RV_DM_FLAGS_124,
    RV_DM_FLAGS_125,
    RV_DM_FLAGS_126,
    RV_DM_FLAGS_127,
    RV_DM_FLAGS_128,
    RV_DM_FLAGS_129,
    RV_DM_FLAGS_130,
    RV_DM_FLAGS_131,
    RV_DM_FLAGS_132,
    RV_DM_FLAGS_133,
    RV_DM_FLAGS_134,
    RV_DM_FLAGS_135,
    RV_DM_FLAGS_136,
    RV_DM_FLAGS_137,
    RV_DM_FLAGS_138,
    RV_DM_FLAGS_139,
    RV_DM_FLAGS_140,
    RV_DM_FLAGS_141,
    RV_DM_FLAGS_142,
    RV_DM_FLAGS_143,
    RV_DM_FLAGS_144,
    RV_DM_FLAGS_145,
    RV_DM_FLAGS_146,
    RV_DM_FLAGS_147,
    RV_DM_FLAGS_148,
    RV_DM_FLAGS_149,
    RV_DM_FLAGS_150,
    RV_DM_FLAGS_151,
    RV_DM_FLAGS_152,
    RV_DM_FLAGS_153,
    RV_DM_FLAGS_154,
    RV_DM_FLAGS_155,
    RV_DM_FLAGS_156,
    RV_DM_FLAGS_157,
    RV_DM_FLAGS_158,
    RV_DM_FLAGS_159,
    RV_DM_FLAGS_160,
    RV_DM_FLAGS_161,
    RV_DM_FLAGS_162,
    RV_DM_FLAGS_163,
    RV_DM_FLAGS_164,
    RV_DM_FLAGS_165,
    RV_DM_FLAGS_166,
    RV_DM_FLAGS_167,
    RV_DM_FLAGS_168,
    RV_DM_FLAGS_169,
    RV_DM_FLAGS_170,
    RV_DM_FLAGS_171,
    RV_DM_FLAGS_172,
    RV_DM_FLAGS_173,
    RV_DM_FLAGS_174,
    RV_DM_FLAGS_175,
    RV_DM_FLAGS_176,
    RV_DM_FLAGS_177,
    RV_DM_FLAGS_178,
    RV_DM_FLAGS_179,
    RV_DM_FLAGS_180,
    RV_DM_FLAGS_181,
    RV_DM_FLAGS_182,
    RV_DM_FLAGS_183,
    RV_DM_FLAGS_184,
    RV_DM_FLAGS_185,
    RV_DM_FLAGS_186,
    RV_DM_FLAGS_187,
    RV_DM_FLAGS_188,
    RV_DM_FLAGS_189,
    RV_DM_FLAGS_190,
    RV_DM_FLAGS_191,
    RV_DM_FLAGS_192,
    RV_DM_FLAGS_193,
    RV_DM_FLAGS_194,
    RV_DM_FLAGS_195,
    RV_DM_FLAGS_196,
    RV_DM_FLAGS_197,
    RV_DM_FLAGS_198,
    RV_DM_FLAGS_199,
    RV_DM_FLAGS_200,
    RV_DM_FLAGS_201,
    RV_DM_FLAGS_202,
    RV_DM_FLAGS_203,
    RV_DM_FLAGS_204,
    RV_DM_FLAGS_205,
    RV_DM_FLAGS_206,
    RV_DM_FLAGS_207,
    RV_DM_FLAGS_208,
    RV_DM_FLAGS_209,
    RV_DM_FLAGS_210,
    RV_DM_FLAGS_211,
    RV_DM_FLAGS_212,
    RV_DM_FLAGS_213,
    RV_DM_FLAGS_214,
    RV_DM_FLAGS_215,
    RV_DM_FLAGS_216,
    RV_DM_FLAGS_217,
    RV_DM_FLAGS_218,
    RV_DM_FLAGS_219,
    RV_DM_FLAGS_220,
    RV_DM_FLAGS_221,
    RV_DM_FLAGS_222,
    RV_DM_FLAGS_223,
    RV_DM_FLAGS_224,
    RV_DM_FLAGS_225,
    RV_DM_FLAGS_226,
    RV_DM_FLAGS_227,
    RV_DM_FLAGS_228,
    RV_DM_FLAGS_229,
    RV_DM_FLAGS_230,
    RV_DM_FLAGS_231,
    RV_DM_FLAGS_232,
    RV_DM_FLAGS_233,
    RV_DM_FLAGS_234,
    RV_DM_FLAGS_235,
    RV_DM_FLAGS_236,
    RV_DM_FLAGS_237,
    RV_DM_FLAGS_238,
    RV_DM_FLAGS_239,
    RV_DM_FLAGS_240,
    RV_DM_FLAGS_241,
    RV_DM_FLAGS_242,
    RV_DM_FLAGS_243,
    RV_DM_FLAGS_244,
    RV_DM_FLAGS_245,
    RV_DM_FLAGS_246,
    RV_DM_FLAGS_247,
    RV_DM_FLAGS_248,
    RV_DM_FLAGS_249,
    RV_DM_FLAGS_250,
    RV_DM_FLAGS_251,
    RV_DM_FLAGS_252,
    RV_DM_FLAGS_253,
    RV_DM_FLAGS_254,
    RV_DM_FLAGS_255
  } rv_dm_mem_id_e;

  // Register width information to check illegal writes for mem interface
  parameter logic [3:0] RV_DM_MEM_PERMIT [281] = '{
    4'b 0001, // index[  0] RV_DM_HALTED
    4'b 0001, // index[  1] RV_DM_GOING
    4'b 0001, // index[  2] RV_DM_RESUMING
    4'b 0001, // index[  3] RV_DM_EXCEPTION
    4'b 1111, // index[  4] RV_DM_WHERETO
    4'b 1111, // index[  5] RV_DM_ABSTRACTCMD_0
    4'b 1111, // index[  6] RV_DM_ABSTRACTCMD_1
    4'b 1111, // index[  7] RV_DM_ABSTRACTCMD_2
    4'b 1111, // index[  8] RV_DM_ABSTRACTCMD_3
    4'b 1111, // index[  9] RV_DM_ABSTRACTCMD_4
    4'b 1111, // index[ 10] RV_DM_ABSTRACTCMD_5
    4'b 1111, // index[ 11] RV_DM_ABSTRACTCMD_6
    4'b 1111, // index[ 12] RV_DM_ABSTRACTCMD_7
    4'b 1111, // index[ 13] RV_DM_ABSTRACTCMD_8
    4'b 1111, // index[ 14] RV_DM_ABSTRACTCMD_9
    4'b 1111, // index[ 15] RV_DM_PROGRAM_BUFFER_0
    4'b 1111, // index[ 16] RV_DM_PROGRAM_BUFFER_1
    4'b 1111, // index[ 17] RV_DM_PROGRAM_BUFFER_2
    4'b 1111, // index[ 18] RV_DM_PROGRAM_BUFFER_3
    4'b 1111, // index[ 19] RV_DM_PROGRAM_BUFFER_4
    4'b 1111, // index[ 20] RV_DM_PROGRAM_BUFFER_5
    4'b 1111, // index[ 21] RV_DM_PROGRAM_BUFFER_6
    4'b 1111, // index[ 22] RV_DM_PROGRAM_BUFFER_7
    4'b 1111, // index[ 23] RV_DM_DATAADDR_0
    4'b 1111, // index[ 24] RV_DM_DATAADDR_1
    4'b 1111, // index[ 25] RV_DM_FLAGS_0
    4'b 1111, // index[ 26] RV_DM_FLAGS_1
    4'b 1111, // index[ 27] RV_DM_FLAGS_2
    4'b 1111, // index[ 28] RV_DM_FLAGS_3
    4'b 1111, // index[ 29] RV_DM_FLAGS_4
    4'b 1111, // index[ 30] RV_DM_FLAGS_5
    4'b 1111, // index[ 31] RV_DM_FLAGS_6
    4'b 1111, // index[ 32] RV_DM_FLAGS_7
    4'b 1111, // index[ 33] RV_DM_FLAGS_8
    4'b 1111, // index[ 34] RV_DM_FLAGS_9
    4'b 1111, // index[ 35] RV_DM_FLAGS_10
    4'b 1111, // index[ 36] RV_DM_FLAGS_11
    4'b 1111, // index[ 37] RV_DM_FLAGS_12
    4'b 1111, // index[ 38] RV_DM_FLAGS_13
    4'b 1111, // index[ 39] RV_DM_FLAGS_14
    4'b 1111, // index[ 40] RV_DM_FLAGS_15
    4'b 1111, // index[ 41] RV_DM_FLAGS_16
    4'b 1111, // index[ 42] RV_DM_FLAGS_17
    4'b 1111, // index[ 43] RV_DM_FLAGS_18
    4'b 1111, // index[ 44] RV_DM_FLAGS_19
    4'b 1111, // index[ 45] RV_DM_FLAGS_20
    4'b 1111, // index[ 46] RV_DM_FLAGS_21
    4'b 1111, // index[ 47] RV_DM_FLAGS_22
    4'b 1111, // index[ 48] RV_DM_FLAGS_23
    4'b 1111, // index[ 49] RV_DM_FLAGS_24
    4'b 1111, // index[ 50] RV_DM_FLAGS_25
    4'b 1111, // index[ 51] RV_DM_FLAGS_26
    4'b 1111, // index[ 52] RV_DM_FLAGS_27
    4'b 1111, // index[ 53] RV_DM_FLAGS_28
    4'b 1111, // index[ 54] RV_DM_FLAGS_29
    4'b 1111, // index[ 55] RV_DM_FLAGS_30
    4'b 1111, // index[ 56] RV_DM_FLAGS_31
    4'b 1111, // index[ 57] RV_DM_FLAGS_32
    4'b 1111, // index[ 58] RV_DM_FLAGS_33
    4'b 1111, // index[ 59] RV_DM_FLAGS_34
    4'b 1111, // index[ 60] RV_DM_FLAGS_35
    4'b 1111, // index[ 61] RV_DM_FLAGS_36
    4'b 1111, // index[ 62] RV_DM_FLAGS_37
    4'b 1111, // index[ 63] RV_DM_FLAGS_38
    4'b 1111, // index[ 64] RV_DM_FLAGS_39
    4'b 1111, // index[ 65] RV_DM_FLAGS_40
    4'b 1111, // index[ 66] RV_DM_FLAGS_41
    4'b 1111, // index[ 67] RV_DM_FLAGS_42
    4'b 1111, // index[ 68] RV_DM_FLAGS_43
    4'b 1111, // index[ 69] RV_DM_FLAGS_44
    4'b 1111, // index[ 70] RV_DM_FLAGS_45
    4'b 1111, // index[ 71] RV_DM_FLAGS_46
    4'b 1111, // index[ 72] RV_DM_FLAGS_47
    4'b 1111, // index[ 73] RV_DM_FLAGS_48
    4'b 1111, // index[ 74] RV_DM_FLAGS_49
    4'b 1111, // index[ 75] RV_DM_FLAGS_50
    4'b 1111, // index[ 76] RV_DM_FLAGS_51
    4'b 1111, // index[ 77] RV_DM_FLAGS_52
    4'b 1111, // index[ 78] RV_DM_FLAGS_53
    4'b 1111, // index[ 79] RV_DM_FLAGS_54
    4'b 1111, // index[ 80] RV_DM_FLAGS_55
    4'b 1111, // index[ 81] RV_DM_FLAGS_56
    4'b 1111, // index[ 82] RV_DM_FLAGS_57
    4'b 1111, // index[ 83] RV_DM_FLAGS_58
    4'b 1111, // index[ 84] RV_DM_FLAGS_59
    4'b 1111, // index[ 85] RV_DM_FLAGS_60
    4'b 1111, // index[ 86] RV_DM_FLAGS_61
    4'b 1111, // index[ 87] RV_DM_FLAGS_62
    4'b 1111, // index[ 88] RV_DM_FLAGS_63
    4'b 1111, // index[ 89] RV_DM_FLAGS_64
    4'b 1111, // index[ 90] RV_DM_FLAGS_65
    4'b 1111, // index[ 91] RV_DM_FLAGS_66
    4'b 1111, // index[ 92] RV_DM_FLAGS_67
    4'b 1111, // index[ 93] RV_DM_FLAGS_68
    4'b 1111, // index[ 94] RV_DM_FLAGS_69
    4'b 1111, // index[ 95] RV_DM_FLAGS_70
    4'b 1111, // index[ 96] RV_DM_FLAGS_71
    4'b 1111, // index[ 97] RV_DM_FLAGS_72
    4'b 1111, // index[ 98] RV_DM_FLAGS_73
    4'b 1111, // index[ 99] RV_DM_FLAGS_74
    4'b 1111, // index[100] RV_DM_FLAGS_75
    4'b 1111, // index[101] RV_DM_FLAGS_76
    4'b 1111, // index[102] RV_DM_FLAGS_77
    4'b 1111, // index[103] RV_DM_FLAGS_78
    4'b 1111, // index[104] RV_DM_FLAGS_79
    4'b 1111, // index[105] RV_DM_FLAGS_80
    4'b 1111, // index[106] RV_DM_FLAGS_81
    4'b 1111, // index[107] RV_DM_FLAGS_82
    4'b 1111, // index[108] RV_DM_FLAGS_83
    4'b 1111, // index[109] RV_DM_FLAGS_84
    4'b 1111, // index[110] RV_DM_FLAGS_85
    4'b 1111, // index[111] RV_DM_FLAGS_86
    4'b 1111, // index[112] RV_DM_FLAGS_87
    4'b 1111, // index[113] RV_DM_FLAGS_88
    4'b 1111, // index[114] RV_DM_FLAGS_89
    4'b 1111, // index[115] RV_DM_FLAGS_90
    4'b 1111, // index[116] RV_DM_FLAGS_91
    4'b 1111, // index[117] RV_DM_FLAGS_92
    4'b 1111, // index[118] RV_DM_FLAGS_93
    4'b 1111, // index[119] RV_DM_FLAGS_94
    4'b 1111, // index[120] RV_DM_FLAGS_95
    4'b 1111, // index[121] RV_DM_FLAGS_96
    4'b 1111, // index[122] RV_DM_FLAGS_97
    4'b 1111, // index[123] RV_DM_FLAGS_98
    4'b 1111, // index[124] RV_DM_FLAGS_99
    4'b 1111, // index[125] RV_DM_FLAGS_100
    4'b 1111, // index[126] RV_DM_FLAGS_101
    4'b 1111, // index[127] RV_DM_FLAGS_102
    4'b 1111, // index[128] RV_DM_FLAGS_103
    4'b 1111, // index[129] RV_DM_FLAGS_104
    4'b 1111, // index[130] RV_DM_FLAGS_105
    4'b 1111, // index[131] RV_DM_FLAGS_106
    4'b 1111, // index[132] RV_DM_FLAGS_107
    4'b 1111, // index[133] RV_DM_FLAGS_108
    4'b 1111, // index[134] RV_DM_FLAGS_109
    4'b 1111, // index[135] RV_DM_FLAGS_110
    4'b 1111, // index[136] RV_DM_FLAGS_111
    4'b 1111, // index[137] RV_DM_FLAGS_112
    4'b 1111, // index[138] RV_DM_FLAGS_113
    4'b 1111, // index[139] RV_DM_FLAGS_114
    4'b 1111, // index[140] RV_DM_FLAGS_115
    4'b 1111, // index[141] RV_DM_FLAGS_116
    4'b 1111, // index[142] RV_DM_FLAGS_117
    4'b 1111, // index[143] RV_DM_FLAGS_118
    4'b 1111, // index[144] RV_DM_FLAGS_119
    4'b 1111, // index[145] RV_DM_FLAGS_120
    4'b 1111, // index[146] RV_DM_FLAGS_121
    4'b 1111, // index[147] RV_DM_FLAGS_122
    4'b 1111, // index[148] RV_DM_FLAGS_123
    4'b 1111, // index[149] RV_DM_FLAGS_124
    4'b 1111, // index[150] RV_DM_FLAGS_125
    4'b 1111, // index[151] RV_DM_FLAGS_126
    4'b 1111, // index[152] RV_DM_FLAGS_127
    4'b 1111, // index[153] RV_DM_FLAGS_128
    4'b 1111, // index[154] RV_DM_FLAGS_129
    4'b 1111, // index[155] RV_DM_FLAGS_130
    4'b 1111, // index[156] RV_DM_FLAGS_131
    4'b 1111, // index[157] RV_DM_FLAGS_132
    4'b 1111, // index[158] RV_DM_FLAGS_133
    4'b 1111, // index[159] RV_DM_FLAGS_134
    4'b 1111, // index[160] RV_DM_FLAGS_135
    4'b 1111, // index[161] RV_DM_FLAGS_136
    4'b 1111, // index[162] RV_DM_FLAGS_137
    4'b 1111, // index[163] RV_DM_FLAGS_138
    4'b 1111, // index[164] RV_DM_FLAGS_139
    4'b 1111, // index[165] RV_DM_FLAGS_140
    4'b 1111, // index[166] RV_DM_FLAGS_141
    4'b 1111, // index[167] RV_DM_FLAGS_142
    4'b 1111, // index[168] RV_DM_FLAGS_143
    4'b 1111, // index[169] RV_DM_FLAGS_144
    4'b 1111, // index[170] RV_DM_FLAGS_145
    4'b 1111, // index[171] RV_DM_FLAGS_146
    4'b 1111, // index[172] RV_DM_FLAGS_147
    4'b 1111, // index[173] RV_DM_FLAGS_148
    4'b 1111, // index[174] RV_DM_FLAGS_149
    4'b 1111, // index[175] RV_DM_FLAGS_150
    4'b 1111, // index[176] RV_DM_FLAGS_151
    4'b 1111, // index[177] RV_DM_FLAGS_152
    4'b 1111, // index[178] RV_DM_FLAGS_153
    4'b 1111, // index[179] RV_DM_FLAGS_154
    4'b 1111, // index[180] RV_DM_FLAGS_155
    4'b 1111, // index[181] RV_DM_FLAGS_156
    4'b 1111, // index[182] RV_DM_FLAGS_157
    4'b 1111, // index[183] RV_DM_FLAGS_158
    4'b 1111, // index[184] RV_DM_FLAGS_159
    4'b 1111, // index[185] RV_DM_FLAGS_160
    4'b 1111, // index[186] RV_DM_FLAGS_161
    4'b 1111, // index[187] RV_DM_FLAGS_162
    4'b 1111, // index[188] RV_DM_FLAGS_163
    4'b 1111, // index[189] RV_DM_FLAGS_164
    4'b 1111, // index[190] RV_DM_FLAGS_165
    4'b 1111, // index[191] RV_DM_FLAGS_166
    4'b 1111, // index[192] RV_DM_FLAGS_167
    4'b 1111, // index[193] RV_DM_FLAGS_168
    4'b 1111, // index[194] RV_DM_FLAGS_169
    4'b 1111, // index[195] RV_DM_FLAGS_170
    4'b 1111, // index[196] RV_DM_FLAGS_171
    4'b 1111, // index[197] RV_DM_FLAGS_172
    4'b 1111, // index[198] RV_DM_FLAGS_173
    4'b 1111, // index[199] RV_DM_FLAGS_174
    4'b 1111, // index[200] RV_DM_FLAGS_175
    4'b 1111, // index[201] RV_DM_FLAGS_176
    4'b 1111, // index[202] RV_DM_FLAGS_177
    4'b 1111, // index[203] RV_DM_FLAGS_178
    4'b 1111, // index[204] RV_DM_FLAGS_179
    4'b 1111, // index[205] RV_DM_FLAGS_180
    4'b 1111, // index[206] RV_DM_FLAGS_181
    4'b 1111, // index[207] RV_DM_FLAGS_182
    4'b 1111, // index[208] RV_DM_FLAGS_183
    4'b 1111, // index[209] RV_DM_FLAGS_184
    4'b 1111, // index[210] RV_DM_FLAGS_185
    4'b 1111, // index[211] RV_DM_FLAGS_186
    4'b 1111, // index[212] RV_DM_FLAGS_187
    4'b 1111, // index[213] RV_DM_FLAGS_188
    4'b 1111, // index[214] RV_DM_FLAGS_189
    4'b 1111, // index[215] RV_DM_FLAGS_190
    4'b 1111, // index[216] RV_DM_FLAGS_191
    4'b 1111, // index[217] RV_DM_FLAGS_192
    4'b 1111, // index[218] RV_DM_FLAGS_193
    4'b 1111, // index[219] RV_DM_FLAGS_194
    4'b 1111, // index[220] RV_DM_FLAGS_195
    4'b 1111, // index[221] RV_DM_FLAGS_196
    4'b 1111, // index[222] RV_DM_FLAGS_197
    4'b 1111, // index[223] RV_DM_FLAGS_198
    4'b 1111, // index[224] RV_DM_FLAGS_199
    4'b 1111, // index[225] RV_DM_FLAGS_200
    4'b 1111, // index[226] RV_DM_FLAGS_201
    4'b 1111, // index[227] RV_DM_FLAGS_202
    4'b 1111, // index[228] RV_DM_FLAGS_203
    4'b 1111, // index[229] RV_DM_FLAGS_204
    4'b 1111, // index[230] RV_DM_FLAGS_205
    4'b 1111, // index[231] RV_DM_FLAGS_206
    4'b 1111, // index[232] RV_DM_FLAGS_207
    4'b 1111, // index[233] RV_DM_FLAGS_208
    4'b 1111, // index[234] RV_DM_FLAGS_209
    4'b 1111, // index[235] RV_DM_FLAGS_210
    4'b 1111, // index[236] RV_DM_FLAGS_211
    4'b 1111, // index[237] RV_DM_FLAGS_212
    4'b 1111, // index[238] RV_DM_FLAGS_213
    4'b 1111, // index[239] RV_DM_FLAGS_214
    4'b 1111, // index[240] RV_DM_FLAGS_215
    4'b 1111, // index[241] RV_DM_FLAGS_216
    4'b 1111, // index[242] RV_DM_FLAGS_217
    4'b 1111, // index[243] RV_DM_FLAGS_218
    4'b 1111, // index[244] RV_DM_FLAGS_219
    4'b 1111, // index[245] RV_DM_FLAGS_220
    4'b 1111, // index[246] RV_DM_FLAGS_221
    4'b 1111, // index[247] RV_DM_FLAGS_222
    4'b 1111, // index[248] RV_DM_FLAGS_223
    4'b 1111, // index[249] RV_DM_FLAGS_224
    4'b 1111, // index[250] RV_DM_FLAGS_225
    4'b 1111, // index[251] RV_DM_FLAGS_226
    4'b 1111, // index[252] RV_DM_FLAGS_227
    4'b 1111, // index[253] RV_DM_FLAGS_228
    4'b 1111, // index[254] RV_DM_FLAGS_229
    4'b 1111, // index[255] RV_DM_FLAGS_230
    4'b 1111, // index[256] RV_DM_FLAGS_231
    4'b 1111, // index[257] RV_DM_FLAGS_232
    4'b 1111, // index[258] RV_DM_FLAGS_233
    4'b 1111, // index[259] RV_DM_FLAGS_234
    4'b 1111, // index[260] RV_DM_FLAGS_235
    4'b 1111, // index[261] RV_DM_FLAGS_236
    4'b 1111, // index[262] RV_DM_FLAGS_237
    4'b 1111, // index[263] RV_DM_FLAGS_238
    4'b 1111, // index[264] RV_DM_FLAGS_239
    4'b 1111, // index[265] RV_DM_FLAGS_240
    4'b 1111, // index[266] RV_DM_FLAGS_241
    4'b 1111, // index[267] RV_DM_FLAGS_242
    4'b 1111, // index[268] RV_DM_FLAGS_243
    4'b 1111, // index[269] RV_DM_FLAGS_244
    4'b 1111, // index[270] RV_DM_FLAGS_245
    4'b 1111, // index[271] RV_DM_FLAGS_246
    4'b 1111, // index[272] RV_DM_FLAGS_247
    4'b 1111, // index[273] RV_DM_FLAGS_248
    4'b 1111, // index[274] RV_DM_FLAGS_249
    4'b 1111, // index[275] RV_DM_FLAGS_250
    4'b 1111, // index[276] RV_DM_FLAGS_251
    4'b 1111, // index[277] RV_DM_FLAGS_252
    4'b 1111, // index[278] RV_DM_FLAGS_253
    4'b 1111, // index[279] RV_DM_FLAGS_254
    4'b 1111  // index[280] RV_DM_FLAGS_255
  };

endpackage
